/***
Programoje nera vienos dalies, tai yra "kiek yra tokiu zodziu kiekvienoje teksto eilutėje?" ir jeigu egzistuoja teksto failas bet jame nera teksto
tada konsoleje ismeta pranesima kad iseinama is programos ribu ir priverstinai sustabdoma
error kuri ismeta:
terminate called after throwing an instance of 'std::out_of_range'
  what():  basic_string::at: __n (which is 0) >= this->size() (which is 0)

taip pat nera skaitymo sakiniais
***/
#include <iostream>
#include <fstream>
#include <string.h>
#include <bits/stdc++.h>
#include <algorithm>

using namespace std;

const char FAILO_PAVADINIMAS[] = "tekstas.txt"; //Failo vardas
const char REZ_FAILO_PAVADINIMAS[] = "rez.txt"; //Rezultatu failo vardas
const int KIEKIS = 100;

class Eil_Kiekis;
class Skaitymas_Eilutes
{
    protected:
        string Eilutes;
    public:
        Skaitymas_Eilutes():Eilutes(""){}
        ~Skaitymas_Eilutes(){}
        friend void Rodyti_Eilutes(Skaitymas_Eilutes, Eil_Kiekis);
};

class Eil_Kiekis
{
    private:
        int Kiekis;
    public:
        Eil_Kiekis():Kiekis(0){}
        ~Eil_Kiekis(){}
        friend void Rodyti_Eilutes(Skaitymas_Eilutes, Eil_Kiekis);
};

void Rodyti_Eilutes(Skaitymas_Eilutes skaityt, Eil_Kiekis rodyt)
{
    ifstream fd(FAILO_PAVADINIMAS);
    ofstream fr(REZ_FAILO_PAVADINIMAS);

    if(fd.fail())
        cout << "Failo nera.\n";
    else
    {
        while (getline(fd, skaityt.Eilutes))
        {
                rodyt.Kiekis++;
        }
        if (rodyt.Kiekis > 0)
        {
            cout << "Eiluciu kiekis faile yra " << rodyt.Kiekis << endl;
            fr << "Eiluciu kiekis faile yra " << rodyt.Kiekis << endl;
        }
    }
    fd.close();
    fr.close();
}

class Pirma_Raide
{
    protected:
        int suma, index;
        string Zodis, B[KIEKIS];
        char pirmaraide;
    public:
        Pirma_Raide(): suma(0), index(0){}
        ~Pirma_Raide(){}
        void Ieskojimas();
};

void Pirma_Raide::Ieskojimas()
{
    ifstream fd (FAILO_PAVADINIMAS);
    ofstream fr(REZ_FAILO_PAVADINIMAS, ios::app);
    getline(fd, Zodis, ' '); ///skaito iki tarpo
    pirmaraide = Zodis.at(0); ///paima pirmo zodzio pirma raide

    while (fd >> Zodis)
    {
        B[index] = Zodis; ///suskaido eilutes zodi ir saugoja masyve
        index++;
    }
    /*** PVZ. yra faile tokios eilutes:
    kazkoks tekstas namai mokykla
    masinos gatves
    po while ciklo masyvas atrodys sitaip:
    B[0] = kazkoks
    B[1] = tekstas
    B[2] = namai
    ir t.t. ***/
    for (int i = 0;i<index;i++)
    {
        if (B[i].find(pirmaraide) == 0) ///tikrina su kokia raide prasideda zodis
        {
            suma++; ///sumuoja kiek zodziu yra, kurie prasideda su tokia pacia raide kaip pats pirmas zodis
        }
    }
    cout << "Surastu zodziu kurie prasideda su " << pirmaraide << ": " << suma+1 << endl;
    fr << "Surastu zodziu kurie prasideda su " << pirmaraide << ": " << suma+1 << endl;
    fd.close();
    fr.close();
}

class Zodziai : public Pirma_Raide
{
    private:
        int index2;
        string C[KIEKIS];

    public:
        Zodziai():index2(1){}
        ~Zodziai(){}
        void Rikiavimas();
};

void Zodziai::Rikiavimas()
{
    ifstream fd (FAILO_PAVADINIMAS);
    ofstream fr(REZ_FAILO_PAVADINIMAS, ios::app);
    getline(fd, Zodis, ' '); ///skaito iki tarpo
    pirmaraide = Zodis.at(0); ///paima pirmo surasto zodzio pirma raide
    C[0] = Zodis; ///pirmas zodis idedamas i masyva ir veliau bus pildomas su rastais zodziais

    while (fd >> Zodis)
    {
        B[index] = Zodis; ///suskaido eilutes zodi ir saugoja masyve
        index++;
    }
    for (int i = 0;i<index;i++)
    {
        if (B[i].find(pirmaraide) == 0)
        {
            C[index2] = B[i]; ///surastus zodzius deda i nauja masyva rikiavimui
            index2++;
        }
    }
    cout << "Surikiuotas zodziu sarasas atvirkscia tvarka:\n";
    fr << "Surikiuotas zodziu sarasas atvirkscia tvarka:\n";
    sort(C, C+index2, greater<string>()); ///rikiavimas
    for (int i = 0;i<index2;i++)
    {
        cout << C[i] << endl;
        fr << C[i] << endl;
    }
    fd.close();
    fr.close();
}

int main()
{
    ifstream fd(FAILO_PAVADINIMAS);
    ///draugiskos funkcijos panaudojimas
    Skaitymas_Eilutes skaityt;
    Eil_Kiekis rodyt;
    Rodyti_Eilutes(skaityt, rodyt);
    ///draugiskos funkcijos panaudojimas

    Pirma_Raide zodis;
    Zodziai rikiuot;
    if (!fd.fail())
    {
        zodis.Ieskojimas();
        rikiuot.Rikiavimas();
    }
    fd.close();
	return 0;
}
